#include <18F4620.h>
#device adc=8

#fuses INTRC_IO,NOWDT,NOPROTECT,BROWNOUT,PUT,NOLVP 

#use delay(clock=32M)
#use rs232(baud=115200,parity=N,xmit=PIN_C6,rcv=PIN_C7,bits=9)

#define GLCD_WIDTH   128

#define FAST_GLCD

#define GLCD_E       PIN_A5   // Enable
#define GLCD_DI      PIN_A2
#define GLCD_CS1     PIN_A0   // Chip Selection 1
#define GLCD_CS2     PIN_A1
#define GLCD_RW      PIN_A4   // Read/Write

#define speech_pin     PIN_A3

#include <HDM64GS12.c>
#include <graphics.c>
#include "maps.h"
#include "splashscreen.h"

#define RTC_SDA  PIN_A6
#define RTC_SCL  PIN_A7

#include <ds1307.c>
#include <1wire1.c>

char  endtas[] =  " SNAKE";

int soly= 28, sagy= 28;
int solhed, saghed;
int topx=64, topy=32, artimx=1, artimy=1, ballturn ;
int16  puansol=0, puansag=0;

int oncekitus1, basilantus1,tusdeger1;
int oncekitus2, basilantus2,tusdeger2;
int oncekitus3, basilantus3,tusdeger3;

float temperature;

  BYTE sec; 
  BYTE min; 
  BYTE hrs; 
  BYTE day; 
  BYTE month; 
  BYTE yr; 
  BYTE dow; 


//-------------------------{}----------------------------
void beep(int16 period){

   while((period--) != 0)
   {
      output_high(speech_PIN);
      delay_ms(1);
      output_low(speech_PIN);
      delay_ms(1);
   }
}

//-------------------------{}----------------------------
void saat() 
{ 
  
  // Set date for -> 15 June 2005 Tuesday 
  // Set time for -> 15:20:55 
  //ds1307_set_date_time(15,6,5,2,15,20,55); 
    
    ds1307_get_date(day,month,yr,dow); 
    ds1307_get_time(hrs,min,sec); 
      
//    printf("\f\%02d/\%02d/\%02d\r\n",day,month,yr); 
//    printf("\%02d:\%02d:\%02d", hrs,min,sec); 
}
//-------------------------{}----------------------------
void rakambas(int x, int y, int rakam){
char  rakamlar[] = "0000";
  
  sprintf(rakamlar,"%02d",rakam); 

glcd_text57(x, y, rakamlar , 2, ON);
}
//-------------------------{}----------------------------

void bitmap_pong(int x, int y)
{
int i,j, sayac=0, k; 
int width = 64;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(pong[sayac],k))
               glcd_pixel(x+j,y+i+k,ON); 
            else 
               glcd_pixel(x+j,y+i+k,OFF); 
      }
      sayac++;
   }
}
}
//-------------------------{}----------------------------
void bitmap_ball(int x, int y)
{
int i,j, sayac=0, k; 
int width = 5;
int height = 5;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(ball[sayac],k))
               glcd_pixel(x+j,y+i+k,ON); 
      }
      sayac++;
   }
}

if(artimx==1){
   switch (ballturn) {

   case 4:glcd_pixel(x+3,y+2,OFF); 
          break;

   case 3:glcd_pixel(x+2,y+1,OFF); 
          break;
           
   case 2:glcd_pixel(x+1,y+2,OFF); 
          break;           
           
   case 1:glcd_pixel(x+2,y+3,OFF); 
          break;           

   default:ballturn=1;
            break; 
   }
}
else{
   switch (ballturn) {

   case 1:glcd_pixel(x+3,y+2,OFF); 
          break;

   case 2:glcd_pixel(x+2,y+1,OFF); 
          break;
           
   case 3:glcd_pixel(x+1,y+2,OFF); 
          break;           
           
   case 4:glcd_pixel(x+2,y+3,OFF); 
          break;           

   default:ballturn=1;
            break; 
   }
}
//glcd_pixel(x+2,y+2,OFF); 
ballturn++;
if (ballturn == 5 ) ballturn=1;

}
//-------------------------{}----------------------------
void bitmap_picpong(int x, int y)
{
int i,j, sayac=0, k; 
int width = 128;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(picpong[sayac],k))
               glcd_pixel(x+j,y+i+k,ON); 
            else 
               glcd_pixel(x+j,y+i+k,OFF); 
      }
      sayac++;
   }
}
}
//-------------------------{}----------------------------
void bitmap_raket(int x, int y)
{
int i,j, sayac=0, k; 
int width = 32;
int height = 32;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(raket[sayac],k))
               glcd_pixel(x+j,y+i+k,ON); 
            //else 
               //glcd_pixel(x+j,y+i+k,OFF); 
      }
      sayac++;
   }
}
}
/*/-------------------------{}----------------------------
void bitmap_top(int x, int y)
{
int i,j, sayac=0, k; 
int width = 18;
int height = 7;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(top[sayac],k))
               glcd_pixel(x+j,y+i+k,ON); 
            else 
               glcd_pixel(x+j,y+i+k,OFF); 
      }
      sayac++;
   }
}
}
*///-------------------------{}----------------------------
void ilkekran(int16 bekleme){


bitmap_raket(44, 10);

//bitmap_pong(30, 0);
glcd_text57(25,56 , endtas , 1, ON);
//saat();
glcd_update();
delay_ms(bekleme);
}

//-------------------------{}----------------------------
void tusbak(){

output_e (0b101);
delay_ms(5);
basilantus1 = input_b() | 0b11100000;
tusdeger1 = basilantus1; 
//if(tusdeger1!=255)beep(4);
output_e (0b110);
delay_ms(5);
basilantus2 = input_b() | 0b11100000;
tusdeger2 = basilantus2; 
//if(tusdeger2!=255)beep(4);
output_e (0b011);
delay_ms(5);
basilantus3 = input_b() | 0b11100000;
tusdeger3 = basilantus3; 
//if(tusdeger3!=255)beep(4);
   
printf("\f(%u) (%u) (%u)", tusdeger1, tusdeger2, tusdeger3); 
}

//-------------------------{}----------------------------


void main()
{

int saatsay, tempsay;

   setup_adc_ports(NO_ANALOGS);
   setup_psp(PSP_DISABLED);
   setup_oscillator(OSC_32MHZ | OSC_PLL_ON);   
   setup_comparator(NC_NC_NC_NC);
   
   printf(" Ozkal's SNAKE GAMEN (%s) (%s )\n\r",__FILENAME__,__DATE__); 

   glcd_init(ON);      

   ilkekran(1000);
   ds1307_init(); 
   

   saatsay=1;
   tempsay=30;   
   port_b_pullups( TRUE );
   oncekitus1=255;
   oncekitus2=255;
   oncekitus3=255;
   

enbas:


   
   glcd_fillScreen(OFF);
   glcd_update();
   
      
//\/\/\/\/\/\/\/\/\/ANA DNG\/\/\/\/\/\/\/\/\/
   while(TRUE){
   
   restart_wdt();
   
   glcd_fillScreen(OFF);
   
   
   
   tusbak();
 

   
   
   if(!saatsay--) {
      saatsay=100;   
//      beep(1);
      saat();    
   }
  
 
   
   rakambas(40, 46 , (int16) hrs );
   rakambas(68, 46 , (int16) min );
   
   
   
   if(!tempsay--) {
      tempsay=255;   
//      beep(5);
      temperature = ds1820_read();   
      printf("\fTemp %f", temperature); 
   }

   rakambas(40, 5 , (int) temperature );   
   rakambas(68, 5 , (temperature - (int) temperature)*100);   
   
   glcd_update();
   }
}

